package com.westvalley.tool.util;

package ..deTemp.1739350932482;

import com.westvalley.sunlord.nbs.wsclient.updatestate.CAPInteropServiceExSoapStub;
import com.westvalley.tool.util.Base64Utils;
import com.westvalley.tool.util.LogUtil;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import weaver.conn.RecordSet;
import weaver.file.Prop;
import weaver.general.BaseBean;
import weaver.general.TimeUtil;
import weaver.general.Util;
import weaver.soa.workflow.request.Cell;
import weaver.soa.workflow.request.DetailTable;
import weaver.soa.workflow.request.Property;
import weaver.soa.workflow.request.Row;

public class NbsUtilG extends BaseBean {
  LogUtil logUtil = LogUtil.log("nbsUtilG.log", "nbs");
  
  public static Map<String, String> getPropertyMap(Property[] property) {
    Map<String, String> m = new HashMap<String, String>();
    byte b;
    int i;
    Property[] arrayOfProperty;
    for (i = (arrayOfProperty = property).length, b = 0; b < i; ) {
      Property p = arrayOfProperty[b];
      m.put(p.getName(), p.getValue());
      b++;
    } 
    return m;
  }
  
  public static List<Map<String, String>> getDetailTableRows(DetailTable detailTable) {
    List<Map<String, String>> listMap = new ArrayList<Map<String, String>>();
    byte b;
    int i;
    Row[] arrayOfRow;
    for (i = (arrayOfRow = detailTable.getRow()).length, b = 0; b < i; ) {
      Row row = arrayOfRow[b];
      Map<String, String> map = new HashMap<String, String>();
      byte b1;
      int j;
      Cell[] arrayOfCell;
      for (j = (arrayOfCell = row.getCell()).length, b1 = 0; b1 < j; ) {
        Cell cell = arrayOfCell[b1];
        map.put(cell.getName(), cell.getValue());
        b1++;
      } 
      map.put("id", row.getId());
      listMap.add(map);
      b++;
    } 
    return listMap;
  }
  
  public static String getTablenameByRequestId(String requestid) {
    String tablename = "";
    RecordSet rs = new RecordSet();
    rs.executeSql("select formid from workflow_base where id=(SELECT workflowid FROM workflow_requestbase where requestid='" + requestid + "')");
    if (rs.next()) {
      String formid = Util.null2String(rs.getString("formid")).replaceAll("-", "");
      tablename = "formtable_main_" + formid;
    } 
    rs = null;
    return tablename;
  }
  
  public static String getWorkcodeById(String userid) {
    String workcode = "";
    RecordSet rs = new RecordSet();
    rs.execute("select workcode from hrmresource where id ='" + userid + "'");
    if (rs.next())
      workcode = rs.getString("workcode"); 
    rs = null;
    return workcode;
  }
  
  public static String getCreateWorkcode(String requestid) {
    String workcode = "";
    RecordSet rs = new RecordSet();
    rs.execute("select workcode from hrmresource where id =(select creater from workflow_requestbase where requestid='" + requestid + "')");
    if (rs.next())
      workcode = rs.getString("workcode"); 
    rs = null;
    return workcode;
  }
  
  public String submitToNbs(String workflowid, String requestid, String userid, int type) throws Exception {
    String progId = Prop.getPropValue("wv_nbs_G", "progId");
    String methodName = Prop.getPropValue("wv_nbs_G", "methodName");
    long time = Long.parseLong(TimeUtil.getCurrentTimeString().replaceAll(" ", "").replaceAll("-", "").replaceAll(":", ""));
    String workcode = getWorkcodeById((new StringBuilder(String.valueOf(userid))).toString());
    String NBS_progId = Prop.getPropValue("wv_nbs_progId_G", workflowid);
    Object[] wParams = { NBS_progId, requestid, Integer.valueOf(type), Long.valueOf(time), workcode };
    this.logUtil.info("单据参数wParams,workflowid【" + workflowid + "】progId【" + NBS_progId + "】requestid【" + requestid + "】type【" + type + "】time【" + time + "】workcode【" + workcode + "】");
    return exeToNbs(progId, methodName, wParams);
  }
  
  public String createNBSBill(String jsonStr) throws Exception {
    String progId = Prop.getPropValue("wv_nbs_G", "progId");
    String methodName = "CreateNBSBill";
    Object[] wParams = { jsonStr };
    this.logUtil.info("单据参数wParams,jsonStr【" + jsonStr + "】");
    return exeToNbs(progId, methodName, wParams);
  }
  
  public String exeToNbs(String progId, String methodName, Object[] wParams) throws Exception {
    String nbsUrl = Prop.getPropValue("wv_nbs_G", "nbsUrl");
    String groupId = Prop.getPropValue("wv_nbs_G", "groupId");
    String language = Prop.getPropValue("wv_nbs_G", "language");
    String userId = Prop.getPropValue("wv_nbs_G", "userId");
    byte[] password = Prop.getPropValue("wv_nbs_G", "password").getBytes("utf-8");
    this.logUtil.info("主参数nbsUrl【" + nbsUrl + "】");
    this.logUtil.info("主参数groupId【" + groupId + "】language【" + language + "】userId【" + userId + "】password【" + password + "】");
    this.logUtil.info("主参数progId【" + progId + "】methodName【" + methodName + "】");
    URL url = new URL(nbsUrl);
    CAPInteropServiceExSoapStub test = new CAPInteropServiceExSoapStub(
        url, null);
    Object ret = test.executeProc(groupId, language, userId, password, 
        progId, methodName, wParams, false, 0);
    this.logUtil.info("NBS响应【" + ret.toString() + "】");
    return ret.toString();
  }
  
  public void getFileStr(String requestid, String docids, StringBuffer sbName, StringBuffer sbUrl) {
    if (!docids.equals("")) {
      String oaUrl = Prop.getPropValue("wv_nbs_G", "OAUrl");
      RecordSet rs = new RecordSet();
      String[] arr = docids.split(",");
      for (int i = 0; i < arr.length; i++) {
        int docid = Util.getIntValue(arr[i], -1);
        if (docid > 0) {
          rs.execute("select a.fileRealPath,a.isZip,a.isaesencrypt,a.aescode,a.imagefilename  from ImageFile a,docimagefile b where a.imageFileId=b.imageFileId and  b.docid ='" + docid + "' order by b.VERSIONID desc");
          if (rs.next()) {
            String imagefilename = rs.getString("imagefilename");
            String furl = String.valueOf(oaUrl) + "?UUID=" + Base64Utils.encode((String.valueOf(requestid) + "_" + docid).getBytes());
            if (sbName.length() == 0) {
              sbName.append(imagefilename);
              sbUrl.append(furl);
            } else {
              sbName.append("|" + imagefilename);
              sbUrl.append("|" + furl);
            } 
            this.logUtil.info("...docid:" + docid + ",imagefilename:" + imagefilename + ",furl:" + furl);
          } 
        } 
      } 
      rs = null;
    } 
  }
}
